Subject: Re: [PATCH RFC net-next v2 1/2] net: phy: marvell: 88e1111: define gigabit features

From: "Russell King (Oracle)" <[email-masked]>
Date: Fri, 2 Jan 2026 13:55:39 +0000

On Fri, Jan 02, 2026 at 12:47:06PM +0000, Russell King (Oracle) wrote:
> I do have patches that add phydev->supported_interfaces which are
> populated at probe time to inform phylink which host interface modes
> that the PHY can be reconfigured between - and this overrides the
> linkmode-derivation of that information - it basically becomes:
> 
>         phy_interface_and(interfaces, phy->supported_interfaces,
>                           pl->config->supported_interfaces);
>         interface = phylink_choose_sfp_interface(pl, interfaces);
>         if (interface == PHY_INTERFACE_MODE_NA) {
>                 phylink_err(pl, "selection of interface for PHY failed\n");
>                 return -EINVAL;
>         }
> 
>         phylink_dbg(pl, "copper SFP: chosen %s interface\n",
>                     phy_modes(interface));
> 
>         ret = phylink_attach_phy(pl, phy, interface);
> 
> and phylink_attach_phy() will result in the PHY driver's config_init
> being called, configuring the appropriate operating mode for the
> PHY, which can then be used to update phydev->supported as appropriate.
> 
> phylink will then look at phydev->supported once the above has
> completed when it will do so in phylink_bringup_phy().
> 
> Deriving the host side PHY interface mode from the link modes has
> always been rather sketchy.

These patches can be found at:

http://git.armlinux.org.uk/cgit/linux-arm.git/log/?h=net-queue

See:

net: phylink: use phy interface mode bitmaps for SFP PHYs
net: phy: add supported_interfaces to Aquantia AQR113C
net: phy: add supported_interfaces to marvell10g PHYs
net: phy: add supported_interfaces to marvell PHYs
net: phy: add supported_interfaces to bcm84881
net: phy: add supported_interfaces to phylib

The reason I didn't end up pushing them (they're almost six years old)
is because I decided that the host_interfaces approach wasn't a good
idea, and dropped those patches. Marek Behún took my patches for
host_interfaces and they were merged in 2022. I had already junked
the host_interfaces approach.

The problem is that we now have two ways that PHY drivers configure
their interface mode - one where config_init() decides on its own
based on the host_interfaces supplied to it, and this approach above
where phylink attempts to choose the interface based on what the
PHY and host (and datapath) can support. These two approaches are
mutually incompatible if we get both phylink _and_ the PHY driver
attempting to do the same thing.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!